(defun c:XX (/ rew e rist rew ele)
;------------------------------------------------------------------------------
;FEHLERBEHANDLUNGSROUTINE
 (defun *error* (msg)
  (setvar "CMDECHO" 0)
  (setvar "OSMODE" aosm)
  (setq rew nil e nil rist nil ele nil)
  (princ msg)(princ)
 )
;------------------------------------------------------------------------------
 (princ "\nZeichne Objekte durch Wahl eines Referenzelementes ... ")
;------------------------------------------------------------------------------
 (setvar "CMDECHO" 0)
 (setq aosm (getvar "OSMODE"))
 (setvar "OSMODE" 109)
 (command "_cecolor" 256 "_celtype" "bylayer")
 (setq alay (getvar "clayer"))
 (setq acol (getvar "cecolor"))
 (setq altp (getvar "celtype"))
 ;(princ "\nGesetzt ist: ... ")
 ;(princ
 ;(strcat "Farbe: " acol " ... Linientyp: " altp " ... Layer: " alay " "))
 (while (not (setq rew 2 e (entsel "\nReferenzelement whlen: ")) ) )
 (if e
  (progn
   (setq e (entget (car e)))
   (if (member (setq rist (cdr (assoc 0 e))) '("LINE" "MLINE" "CIRCLE" "ARC" "TEXT" "INSERT" "POLYLINE" "LWPOLYLINE" "TRACE" "POINT" "SOLID" "3DFACE" "DIMENSION"))
    (setq rew 1)
    (princ
    (strcat "\n" rist ": Element wird nicht untersttzt "))
   )
  )
 )
;==============================================================================
 (IF (= rew 1)
  (progn
   (command "_CECOLOR" (cdr (assoc 62 e))
            "_CELTYPE" (cdr (assoc 6 e))
            "_CLAYER"  (cdr (assoc 8 e))
   )
   (setq alay (getvar "clayer"))
   (setq acol (getvar "cecolor"))
   (setq altp (getvar "celtype"))
   (princ "\nGesetzt ist: ... ")
   (princ
   (strcat "Farbe: " acol " ... Linientyp: " altp " ... Layer: " alay " "))
;------------------------------------------------------------------------------
   (setq ele 1)
   (while ele
    (cond
;..............................................................................
     ((= rist "LINE") (setvar "CMDECHO" 0)(terpri) (command "_LINE" pause pause) );(command "_LINE" pause pause "") )
;..............................................................................
     ((= rist "POLYLINE") (setvar "CMDECHO" 0)(terpri)
      (command "_PLINE" pause)
      (if (and (= 0.0 (cdr (assoc 40 e))) (= 0.0 (cdr (assoc 41 e))) )
       (command "_W" 0.0 0.0 pause pause)
       (command "_W" (cdr (assoc 40 e)) (cdr (assoc 41 e)) pause pause)
      )
     )
;..............................................................................
     ((= rist "LWPOLYLINE") (setvar "CMDECHO" 0)(terpri)
      (command "_PLINE" pause)
      (if (and (= 0.0 (cdr (assoc 40 e))) (= 0.0 (cdr (assoc 41 e))) )
       (command "_W" 0.0 0.0 pause pause)
       (command "_W" (cdr (assoc 40 e)) (cdr (assoc 41 e)) pause pause)
      )
     )
;..............................................................................
     ((= rist "MLINE") (setvar "CMDECHO" 0)(terpri)
      (princ "Stil: ")(princ  (cdr (assoc 2 e))) (princ ", Mastab: ")(princ  (cdr (assoc 40 e)))
      (command "_MLINE" "M" (cdr (assoc 40 e)) pause pause)
     )
;..............................................................................
     ((= rist "TRACE") (setvar "CMDECHO" 0)(terpri) (command "_TRACE" pause) )
;..............................................................................
     ((= rist "CIRCLE") (setvar "CMDECHO" 0)(terpri) (command "_CIRCLE" pause pause) )
;..............................................................................
     ((= rist "ARC") (setvar "CMDECHO" 0)(terpri) (command "_ARC" pause pause pause) )
;..............................................................................
     ((= rist "POINT") (setvar "CMDECHO" 0)(terpri) (command "_POINT" pause) )
;..............................................................................
     ((= rist "SOLID") (setvar "CMDECHO" 0)(terpri) (command "_SOLID") )
;..............................................................................
     ((= rist "3DFACE") (setvar "CMDECHO" 0)(terpri) (command "_3DFACE") )
;..............................................................................
     ((= rist "INSERT") (setvar "CMDECHO" 0)(terpri)
      (if (= (substr (cdr (assoc 2 e)) 1 1) "*")
       (progn
        (princ "\nUnbekannter Block - Blockeinfgung nicht ausgefhrt ! ")
        (EXIT)
       )
       (progn
        (command "_INSERT" (cdr (assoc 2 e)))
        (command pause (cdr (assoc 41 e)) (cdr (assoc 42 e)))
       )
      )
     )
;..............................................................................
     ((= rist "DIMENSION")
      (setq bs (cdr (assoc 3 e)))
      (setq p2 (cdr (assoc 70 e)))
      (terpri)
      (princ (strcat "\nDer Bemstil ist: " bs "\n"))
      (command "_DIMSTYLE" "_r" bs)
;. .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .
      (COND
       ((or (= p2 32) (= p2 160)(= p2 0)(= p2 128)) (princ "LINEAR ")
        (setvar "CMDECHO" 0)
        (command "_DIMLINEAR" pause pause pause)
       )
;. .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .
       ((or (= p2 33) (= p2 161)(= p2 1)(= p2 129)) (princ "AUSGERICHTET ")
        (setvar "CMDECHO" 0)
        (command "_DIMALIGNED" pause pause pause)
       )
;. .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .
       ((or (= p2 34) (= p2 162)(= p2 2)(= p2 130)) (princ "WINKEL ")
        (setvar "CMDECHO" 0)
        (command "_DIMANGULAR" pause pause pause)
       )
;. .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .
       ((or (= p2 35) (= p2 163)(= p2 3)(= p2 131)) (princ "DURCHMESSER ")
        (setvar "CMDECHO" 0)
        (command "_DIMDIAMETER" pause pause)
       )
;. .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .
       ((or (= p2 36) (= p2 164)(= p2 4)(= p2 132)) (princ "RADIUS ")
        (setvar "CMDECHO" 0)
        (command "_DIMRADIUS" pause pause)
       )
;. .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .
       ((or (= p2 37) (= p2 165)(= p2 5)(= p2 133)) (princ "WINKEL 3Punkt ")
        (setvar "CMDECHO" 0)
        (command "_DIMANGULAR" pause pause)
       )
;. .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .
       ((or (= p2 38) (= p2 166) (= p2 102) (= p2 230)) (princ "ORDINATE ")
        (setvar "CMDECHO" 0)
        (command "_DIMORDINATE" pause pause)
       )
      (T)
      )
     )
;..............................................................................
     ((= rist "TEXT") (setvar "CMDECHO" 0)(terpri)
      (setq n (cdr (assoc 72 e)))
      (princ "\nText einfgepunkt:")
      (command "_DTEXT" "_S" (cdr (assoc 7 e)))
      (if (/= n 0) (command (nth n (list "" "_C" "_R" "_A" "_M" "_F"))))
      (cond
       ((or (= n 0)(= n 1)(= n 2)(= n 4)) (command pause))
       ((or (= n 3)(= n 5)) (command pause pause))
      )
      (if (/= n 3) (command (cdr (assoc 40 e))))
      (if (and (/= n 3) (/= n 5))
       (if (= (cdr (assoc 4 cl$lst)) 1)
        (progn
         (setq w1 (- (cdr (assoc 50 e))
                     (angle (trans (getvar "UCSORG") 0 1) (getvar "UCSXDIR"))
                  )
         )
         (if (minusp w1) (setq w1 (+ (* pi 2.0) w1)) )
         (command (* 180 (/ w1 pi)))
        )
        (command pause)
       )
      )
     )
     (setvar "CMDECHO" 0)
     (setvar "OSMODE" aosm)
     (T)
    )
   )
  )
 )
)
(princ "\nZeichne.lsp wurde geladen. Starten mit dem Befehl \"XX\"." )
(princ)
